package src

import (
	"crypto/rand"
	"crypto/rsa"
	"crypto/x509"
	"encoding/base64"
)

func GenRsa() (priKey string, pubKey string, err error) {
	privateKey, err := rsa.GenerateKey(rand.Reader, 2048)
	if err != nil {
		return "", "", err
	}
	publicKey := &privateKey.PublicKey
	publicKeyBytes := x509.MarshalPKCS1PublicKey(publicKey)
	//publicKeyBytes, err := x509.MarshalPKIXPublicKey(publicKey)
	//if err != nil {
	//	return "", "", err
	//}
	pubKey = base64.StdEncoding.EncodeToString(publicKeyBytes)
	//pemBlock := &pem.Block{
	//	Type:  "",
	//	Bytes: publicKeyBytes,
	//}
	//pubKey = string(pem.EncodeToMemory(pemBlock))
	//x509.MarshalPKCS8PrivateKey(privateKey)
	privateKeyBytes, err := x509.MarshalPKCS8PrivateKey(privateKey)
	if err != nil {
		return "", "", err
	}
	priKey = base64.StdEncoding.EncodeToString(privateKeyBytes)
	//pemBlock = &pem.Block{
	//	Type:  "",
	//	Bytes: privateKeyBytes,
	//}
	//priKey = string(pem.EncodeToMemory(pemBlock))
	err = nil
	return
}
